/***************************************************************************
*                                                                          *
*  Copyright (C) Golaem S.A.  All Rights Reserved.                         *
*                                                                          *
****************************************************************************/

#pragma once

#include "glmRTTI.h"

#include <glmGolaemCharacterDeclarations.h> // GolaemCharacter declarations

namespace glm
{
    class GeometryAssetV2;

    /**
	* \brief Geometry Asset
	*/
    class GLM_CORE_API GeometryAssetV3
    {
        GLM_RTTI("f220e5a4-c79f-4961-8190-a27d2b62d1c2", GeometryAssetV3, addAttributes);

    public:
        GLM_CLASS_STAT_ID( glm::MemoryStatIds::GolaemShared);

        /// The geometry file
        glm::GlmString _filename;

        /// bounding box halfExtents
        Vector3 _halfExtentsYUp;

        float _LODMinDistance;
        float _LODMaxDistance;

        glm::GlmString _deepFilename;

        GeometryAssetV3();

        void createFromV2(const GeometryAssetV2& geoAssetV2);

        GeometryFileType::Value getGeometryFileType() const;

        void getAbsoluteFile(const GlmString& inFile, glm::GlmString& resultFilePath, const char* referenceDirectory) const;

        void getAbsoluteGeometryFile(glm::GlmString& resultFilePath, const char* referenceDirectory) const;
        
        void getAbsoluteDeepFile(glm::GlmString& resultFilePath, const char* referenceDirectory) const;

    protected:
        /**
		* \brief Inspection needed method declaring the inspectable attributes.
		*/
        static void addAttributes();
    };
} // namespace glm
